.386
.model flat,stdcall
option casemap:none

include P2kCopy.inc
include \RadAsm\masm\inc\radbg.inc
;
; Vkim's debug
;
include \radasm\masm\inc\debug.inc
includelib \Radasm\masm\lib\debug.lib

DBGWIN_DEBUG_ON = 1 ;turn it off if you don't want to include debug info into the program
DBGWIN_EXT_INFO = 1 ;turn it off if you don't want to include extra debug info into the program

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
;	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
	
		;invoke ShowWindow,hWnd,SW_HIDE
		;invoke Sleep,5000
		;invoke ShowWindow,hWnd,SW_SHOWNORMAL
		
		invoke PostMessage,hWin,WM_COMMAND,1111,0
	
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.elseif eax==1111
			invoke LoadLibrary,ADDR libName
			mov hLib, eax
			.if eax!=0
				invoke GetProcAddress,hLib,ADDR Func_COM_Find
				mov A_COM_Find,eax
				invoke GetProcAddress,hLib,ADDR Func_Switch_mode
				mov A_Switch_mode,eax
				invoke GetProcAddress,hLib,ADDR Func_FindUSBClass
				mov A_FindUSBClass,eax
				invoke GetProcAddress,hLib,ADDR Func_P2K_Restart
				mov A_P2K_Restart,eax
				invoke GetProcAddress,hLib,ADDR Func_P2K_Suspend
				mov A_P2K_Suspend,eax
				invoke GetProcAddress,hLib,ADDR Func_P2K_Flash
				mov A_P2K_Flash,eax
				invoke GetProcAddress,hLib,ADDR Func_P2K_SendCommand
				mov A_P2K_SendCommand,eax
				invoke GetProcAddress,hLib,ADDR Func_GetVolNames
				mov A_GetVolNames,eax
				invoke GetProcAddress,hLib,ADDR Func_File_GetFreeSpace
				mov A_File_GetFreeSpace,eax
				invoke GetProcAddress,hLib,ADDR Func_GetModelName
				mov A_GetModelName,eax
				invoke GetProcAddress,hLib,ADDR Func_FSAC_search_file
				mov A_FSAC_search_file,eax
				invoke GetProcAddress,hLib,ADDR Func_GetFSRecords
				mov A_GetFSRecords,eax
				invoke GetProcAddress,hLib,ADDR Func_FSAC_open
				mov A_FSAC_open,eax
				invoke GetProcAddress,hLib,ADDR Func_FSAC_close
				mov A_FSAC_close,eax
				invoke GetProcAddress,hLib,ADDR Func_FSAC_read
				mov A_FSAC_read,eax
				invoke GetProcAddress,hLib,ADDR Func_FSAC_write
				mov A_FSAC_write,eax
				invoke GetProcAddress,hLib,ADDR Func_FSAC_seek
				mov A_FSAC_seek,eax
				invoke GetProcAddress,hLib,ADDR Func_FileRead
				mov A_FileRead,eax
				invoke GetProcAddress,hLib,ADDR Func_File_CountEx
				mov A_File_CountEx,eax
				invoke GetProcAddress,hLib,ADDR Func_P2k_MasterReset
				mov A_P2k_MasterReset,eax
				;
				; check connection
				;
				call A_COM_Find
				.if eax!=-1
					mov isAT,1
					call A_Switch_mode
					.if eax==0
					.else
						invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm20
					.endif	
				.else
					invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm10
				.endif
				;
				; if com not found maybe already in p2kmode (or not connected)
				;
				.if isAT==1		
					invoke Sleep,5000
				.endif	
				call A_FindUSBClass
				;
				; if connected do the job
				;			
				.if eax!=-1
					invoke GetCL,0,addr S_Launchdir
					invoke GetCL,1,addr S_Source
					.if eax==1
						inc parmnum
						invoke GetCL,2,addr S_Destination
						.if eax==1
							inc parmnum
							invoke GetCL,3,addr S_Option
							.if eax==1
								inc parmnum
							.endif
						.endif
					.endif		
					;invoke revstr,addr S_Launchdir,addr buffer
					;invoke InString,1,addr buffer, addr backslash
					;mov esi,offset buffer
					;add esi,eax
					;dec esi
					;invoke revstr,esi,addr S_Launchdir
					mov esi,offset S_Launchdir
					invoke lstrlen,offset S_Launchdir
					add esi,eax
					.while byte ptr [esi]!="\"
						dec esi
					.endw
					inc esi
					mov byte ptr [esi],0
					invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr S_Launchdir
					invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr S_Source
					invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr S_Destination
					invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr S_Option
					;
					; check parameters
					;
					.if parmnum >1
						mov esi,offset S_Source 
						mov edi,offset S_Destination 
						.if byte ptr [edi]=="/"
						;
						; upload
						;
							;
							; read file into malloc-ed buffer
							;
							invoke CreateFile,addr S_Source,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
						    ;DbgDump offset S_Source,32
							mov	hReadFile,eax
							invoke GetFileSize,hReadFile,addr nBytes
							inc	eax
							mov	nBytes,eax
							invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
							mov	hMemFile,eax
							invoke ReadFile,hReadFile,hMemFile,nBytes,addr nBytes,FALSE
							invoke CloseHandle,hReadFile
							;
							; check destination
							;
							
							;
							; do p2k copy
							;
							push offset buf_aa
							call A_File_GetFreeSpace
							.if eax!=-1
								push 4 ;attrib for read, this is unsignificant
								push offset S_Destination
								call A_FSAC_open ; if file not found, new file will be create
								.if eax==0
									push 0
									push 0
									call A_FSAC_seek ; seek to the beginning of file
									.if eax==0
										push nBytes  ;P2kFilesize
										push hMemFile
										call A_FSAC_write
										.if eax==0
											call A_FSAC_close
											.if eax==0
												mov allok,1
											.else
												invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm50
											.endif	
										.else
											invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm60
										.endif		
									.else
										invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm70
									.endif		
								.else
									invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm80
								.endif		
							.else
								invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm90
							.endif		
							;
							; free mem
							;
							invoke GlobalFree,hMemFile
							;
							; if no errors, exit silently
							;
							.if allok==1
								;invoke SendMessage,hWin,WM_CLOSE,0,0
							.endif
						.elseif byte ptr [esi]=="/"
						;
						; download
						;
							;
							; make mask into buffer2
							;
;							invoke revstr,addr S_Source,addr buffer
;							invoke InString,1,addr buffer, addr slash
;							;mov pos1,eax
;							mov esi,offset buffer
;							add esi,eax
;							dec esi
;							invoke revstr,esi,addr buffer2
							invoke lstrcpy,addr buffer2,addr S_Source
							mov esi,offset buffer2
							invoke lstrlen,offset S_Source
							add esi,eax
							.while byte ptr [esi]!="/"
								dec esi
							.endw
							inc esi
							mov byte ptr [esi],0
							invoke lstrcat,addr buffer2,addr astr
							invoke InString,1,addr S_Source, addr dot
							mov esi,offset S_Source
							add esi,eax
							invoke lstrcat,addr buffer2,esi
						    ;DbgDump offset buffer2,32
							;invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr buffer2
							;
							; get filenum and malloc
							; 
							push offset buffer2 ;filter=/a/mobile/audio/*.mp3
							call A_File_CountEx ;
			;				inc eax
			;				inc eax
							mov ebx,110h
							mul ebx 
							invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
							mov	hMemFile2,eax
							;
							; get filelist into malloced buffer
							; 
							mov eax,0
							.while eax==0
								push offset buffer2
								push hMemFile2
								;push hMemFile2
								;pop hMemFile2p
								push 0
								call A_GetFSRecords
								push eax
								mov esi,offset buffer2
								mov ebx,[esi]
								mov loadedfile,ebx
								mov ebx,[esi+4]
								mov P2kRecordLenght,ebx
							    ;
							    ; search buffer for filename
							    ;
							    mov esi,offset S_Source
							    mov edi,hMemFile2
							    ;DbgDump edi,32
							    ;nop
							    .while loadedfile!=0
								    invoke lstrcmp,esi,edi
								    .break .if eax==0
							    	add edi,P2kRecordLenght
								    dec loadedfile
							    .endw
							    .if eax==0
							    	mov found,1
							    .endif
								pop eax
							    .break .if found==1
							.endw	
						    ;DbgDump edi,140h
						    mov eax,found
						    .if found==1
							    ;
							    ; get p2kfilesize
							    ;
							    add edi,P2kRecordLenght
							    mov eax,[edi-4]
							    xchg al,ah
							    rol eax,16
							    xchg al,ah
							    mov nBytes,eax
							    ;
							    ; malloc for read file
							    ;
								invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,nBytes
								mov	hMemFile3,eax
							    ;
								; do p2k fileread
								;
								push 4 ;attrib for read, this is unsignificant
								push offset S_Source
								call A_FSAC_open ; if file not found, new file will be create
								.if eax==0
									push 0
									push 0
									call A_FSAC_seek ; seek to the beginning of file
									.if eax==0
										push nBytes  ;P2kFilesize
										push hMemFile3
										call A_FSAC_read
										.if eax==0
											call A_FSAC_close
											.if eax==0
												mov allok,1
											.else
												invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm50
											.endif	
										.else
											invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm61
										.endif		
									.else
										invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm70
									.endif		
								.else
									invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm80
								.endif
							.else
								invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm81
							.endif		
							;
							; write file
							;
							invoke DeleteFile,addr S_Destination
							invoke CreateFile,addr S_Destination,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,0
							mov hSaveFile,eax
							invoke SetFilePointer,hSaveFile,0,0,FILE_END
							invoke WriteFile,hSaveFile,hMemFile3,nBytes,addr writtenb,0
							invoke CloseHandle,hSaveFile														
							;
							; free mem
							;
							invoke GlobalFree,hMemFile3
							invoke GlobalFree,hMemFile2
							;
							; if no errors, exit silently
							;
							.if allok==1
								;invoke SendMessage,hWin,WM_CLOSE,0,0
							.endif
						.endif			
					.else
						invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm40
					.endif	
				.else
					;
					; timeout, not connected
					;	
					invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm30
				.endif
			.else	
				invoke SendDlgItemMessage,hWin,1001,LB_ADDSTRING,0,addr comm0
			.endif	
		.endif
;	.elseif eax==WM_SIZE
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
